xds_b.pnr.model = {}

local function createAttachment()
   return {id='', mime='', uuid='', content=''}
end

local function createAuthorInstitution()
   return {value=''}
end

local function createAuthorRole()
   return {value=''}
end

local function createAuthorSpeciality()
   return {value=''}
end

local function createAuthor()
   return {
      person={
         first='', 
         last='', 
         middle='', 
         prefix='', 
         suffix=''},
      institutions={create=createAuthorInstitution},
      roles={create=createAuthorRole},
      specialities={create=createAuthorSpeciality}
   }
end

local function createId()
   return {id_type='', value=''}
end

local function createCode()
   return {code_type='', name=''}
end

local function createDocumentEntry()
   return {
      id='',
      mime='',
      creationTime='',
      languageCode='',
      sourcePatientId='',
      serviceStartTime='',
      serviceStopTime='',
      sourcePatientInfo={
         PID3='',
         PID5='',
         PID7='',
         PID8='',
         PID11=''
      },
      name='',
      description='',
      authors={create=createAuthor},
      codes={create=createCode},
      ids={create=createIds},
      association_status=''
   }
end

return {
   url='',
   attachments={create=createAttachment},
   submissionSet={
      id='',
      submissionTime='',
      name='',
      description='',
      authors={create=createAuthor},
      ids={create=createId},
      codes={create=createCode}
   },
   documentEntries={create=createDocumentEntry}
}
         
